// FIRST QUEEN (PC-88VA) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*26*154];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(&buff[_offset], 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;
	int dn=0;

	// ȃf[^ʒu (Disk A)
	struct fpos md[] =
	{
		{ 0x7a, 0x0c, 0x0900 },	// 
		{ 0x7b, 0x01, 0x0d00 },	// 
		{ 0x80, 0x01, 0x0d00 },	// 
		{ 0x80, 0x0e, 0x0d00 },	// 
		{ 0x81, 0x01, 0x0d00 },	// 
		{ 0x81, 0x0e, 0x0d00 },	// 
		{ 0x82, 0x01, 0x0d00 },	// 
		{ 0x82, 0x0e, 0x0d00 },	// 
		{ 0x83, 0x01, 0x0d00 },	// 
		{ 0x83, 0x0e, 0x0d00 },	// 
		{ 0x84, 0x01, 0x0d00 },	// 
		{ 0x84, 0x0e, 0x0d00 },	// 
		{ 0x85, 0x01, 0x0d00 },	// 
		{ 0x85, 0x0e, 0x0d00 },	// 
		{ 0x86, 0x01, 0x0d00 },	// 
		{ 0x86, 0x10, 0x0d00 },	// 
		{ 0x87, 0x10, 0x0d00 },	// 
		{ 0x88, 0x10, 0x0d00 },	// 
		{ 0x89, 0x10, 0x0d00 },	// 
		{ 0x8a, 0x10, 0x0d00 },	// 
		{ 0x8b, 0x10, 0x0d00 },	// 
		{ 0x8c, 0x10, 0x0d00 },	// 
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	if (argc<2 || argc>3)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
	}

	if (argc==3)
	{
		// fBXNԍw
		dn = *argv[2]-'0';
		if (dn<1 || dn>2)
		{
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
		}
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x1a);
		// fBXN
		disk.ReadDATA1(0x01, 0x00, 0x01, 0x01, 0x01, buff, 0x100);
		if ((buff[0x0000]==0x40 && dn==0) || dn==1)
		{
			fprintf(stderr, "Disk A F܂.\n");
			// hCo؂o
			fcut("DRIVER", 0x7a, 0x3d, 0x00, 0x02, 0x01, 0x0000, 0x0a00);
			// ȃf[^؂o
			for (i=0; md[i].sec; i++)
			{
				sprintf(fname,"MUS%02d",i);
				fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, md[i].size);
			}
			if (dn) return 0; else continue;
		}
		if ((buff[0x0000]==0x05 && dn==0) || dn==2)
		{
			fprintf(stderr, "Disk BF܂.\n");
			if (dn) return 0; else continue;
		}
	}
	return 0;
}

